#!C:\Perl\bin\perl.exe

# Automatically ban IP addresses in IIS: updated 11-8-07
# Perl code by Dave (projects.digi-dl.com)
# C(Sharp) code by Scott Burgett

# The location of the program log files (must have read/write permissions)
my $dir="C:\\inetpub\\www.yoursite.com\\cgi-bin\\";

# Your website IIS identifier number: default is 1
my $id="1"; 

###################################################################

while(1){
# open the banned ip list file to obtain IP address
open(IP_FILE, $dir."banned_ip_list.log")   || die "Error: can't open banned file: $!";
	my $ip = <IP_FILE>; chomp($ip);
        # If file is empty use dummy IP to avoid errors
	if(!$ip) { $ip="1.2.3.4"; }
close(IP_FILE)   || die "Error: can't close banned file: $!";
# generate c sharp source code file
open(SOURCE_FILE, "> build_deny_list.cs")   || die "Error: can't open source file: $!";
	print (SOURCE_FILE " using System;
using System.IO;
using System.Collections;
using System.DirectoryServices;
using System.Reflection;

namespace soccerwrek
{
class IISWMI
{      

[STAThread]
static void Main(string[] args) 
{
try

{
// retrieve the directory entry for the root of the IIS server
System.DirectoryServices.DirectoryEntry IIS = new System.DirectoryServices.DirectoryEntry(\"IIS://localhost/w3svc/",$id,"/root\");

// retrieve the list of currently denied IPs
Console.WriteLine(\"Retrieving the list of currently denied IPs.\");

// get the IPSecurity property
Type typ = IIS.Properties[\"IPSecurity\"][0].GetType();
object IPSecurity = IIS.Properties[\"IPSecurity\"][0];

// retrieve the IPDeny list from the IPSecurity object
Array origIPDenyList = (Array) typ.InvokeMember(\"IPDeny\", 
BindingFlags.DeclaredOnly | 
BindingFlags.Public | BindingFlags.NonPublic | 
BindingFlags.Instance | BindingFlags.GetProperty, null, IPSecurity, null);

// display what was being denied
foreach(string s in origIPDenyList)
Console.WriteLine(\"Before: \" + s);

// check GrantByDefault.  This has to be set to true, or what we are doing will not work.
bool bGrantByDefault = (bool) typ.InvokeMember(\"GrantByDefault\", 
BindingFlags.DeclaredOnly | 
BindingFlags.Public | BindingFlags.NonPublic | 
BindingFlags.Instance | BindingFlags.GetProperty, null, IPSecurity, null);

Console.WriteLine(\"GrantByDefault = \" + bGrantByDefault);
if(!bGrantByDefault)
{
typ.InvokeMember(\"GrantByDefault\", 
BindingFlags.DeclaredOnly | 
BindingFlags.Public | BindingFlags.NonPublic | 
BindingFlags.Instance | BindingFlags.SetProperty, null, IPSecurity, new object[] {true});
}

// update the list of denied IPs.  This is a complete replace.  If you want to maintain what
// was already being denied, you need to make sure those IPs are in here as well.  This area
// will be where you will most likely modify to your needs as this is just an example.
Console.WriteLine(\"Updating the list of denied IPs.\");
object[] newIPDenyList = new object[1];
newIPDenyList[0] = \"",$ip,", 255.255.255.255\";
Console.WriteLine(\"Calling SetProperty\");

// add the updated list back to the IPSecurity object
typ.InvokeMember(\"IPDeny\", 
BindingFlags.DeclaredOnly | 
BindingFlags.Public | BindingFlags.NonPublic | 
BindingFlags.Instance | BindingFlags.SetProperty, null, IPSecurity, new object[] {newIPDenyList});
            
IIS.Properties[\"IPSecurity\"][0] = IPSecurity;            
Console.WriteLine(\"Commiting the changes.\");

// commit the changes
IIS.CommitChanges();
IIS.RefreshCache();

// check to see if the update took
Console.WriteLine(\"Checking to see if the update took.\");
IPSecurity = IIS.Properties[\"IPSecurity\"][0];
Array y = (Array) typ.InvokeMember(\"IPDeny\", 
BindingFlags.DeclaredOnly | 
BindingFlags.Public | BindingFlags.NonPublic | 
BindingFlags.Instance | BindingFlags.GetProperty, null, IPSecurity, null);
foreach(string s in y)
Console.WriteLine(\"After:  \" + s);
}
catch (Exception e) 
{
Console.WriteLine(\"Error: \" + e.ToString());
}
}
}
}");
close(SOURCE_FILE)  || die "Error: can't close source file: $!";
# compile the binary
sleep(2);
system("C:\\WINDOWS\\Microsoft.NET\\Framework\\v1.1.4322\\csc /out:build_deny_list.exe /target:exe build_deny_list.cs");
#run the binary to upload new ip to the IIS deny list
sleep(2);
system("build_deny_list.exe");
# delete used source and binary files to avoid errors on next run
sleep(2);
system("del build_deny_list.cs");
system("del build_deny_list.exe");
# How often to check for banned IP's - in seconds
sleep(60);		
}
